<template>
    <div class="flex flex-col items-center w-full">
        <editor-home-header :open="isSlideOverMenuOpen" @open="handleSlideOverToogle"></editor-home-header>
        <slide-over-menu :open="isSlideOverMenuOpen" @close="handleSlideOverToogle"></slide-over-menu>
        <section class="flex justify-center w-full">
            <search @search="handleSearch"></search>
        </section>
        <router-view></router-view>
        <add-button @createNotebook="openAddNotebookForm" @createTag="openAddTagForm"></add-button>
        <add-notebook-form :open="isAddNotebookFormOpen" @close="closeAddNotebookForm"></add-notebook-form>
        <add-tag-form :open="isAddTagFormOpen" @close="closeAddTagForm"></add-tag-form>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import EditorHomeHeader from '@/app/Editor/components/EditorHomeHeader.vue'
import SlideOverMenu from '@/app/Editor/components/SlideOverMenu.vue'
import Search from '@/app/Editor/components/Notebook/Search.vue'
import AddButton from '@/app/Editor/components/Notebook/AddButton.vue'
import AddNotebookForm from '@/app/Editor/components/Notebook/AddNotebookForm.vue'
import AddTagForm from '@/app/Editor/components/Notebook/AddTagForm.vue'

@Component({
    components: {
        EditorHomeHeader,
        SlideOverMenu,
        Search,
        AddButton,
        AddNotebookForm,
        AddTagForm,
    },
})
export default class Editor extends Vue {
    // Lifecycle

    created() {
        if (!this.$store.state.Notebooks.notebooks) {
            this.$store.dispatch('init').catch(e => {
                throw new Error(e)
            })
        }
    }

    // Data

    isSlideOverMenuOpen: boolean = false
    isAddNotebookFormOpen: boolean = false
    isAddTagFormOpen: boolean = false

    // Computed

    // Watchers

    // Methods

    handleSearch(searchTerm: string) {}

    handleSlideOverToogle(state: boolean) {
        this.isSlideOverMenuOpen = state
    }

    handleNotebookSelection() {}

    openAddNotebookForm() {
        this.isAddNotebookFormOpen = true
    }

    openAddTagForm() {
        this.isAddTagFormOpen = true
    }

    closeAddNotebookForm() {
        this.isAddNotebookFormOpen = false
    }
    closeAddTagForm() {
        this.isAddTagFormOpen = false
    }
}
</script>